//+------------------------------------------------------------------+
//|                                                   qwqwqwwqwq.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 LimeGreen
extern int RSIPeriod=14;

double ExtBuf[];
double RSIBuf[];
double RSIArr[];
double RSI[];
double PosBuf[];
double NegBuf[];

int init()
{
	SetIndexBuffer(0,ExtBuf); SetIndexStyle(0,DRAW_LINE);
	SetIndexBuffer(1,RSIBuf); SetIndexStyle(1,DRAW_LINE);
	SetIndexBuffer(2,RSIArr); SetIndexStyle(2,DRAW_LINE);
	SetIndexBuffer(3,RSI); SetIndexStyle(3,DRAW_LINE);
	SetIndexBuffer(4,PosBuf);   SetIndexStyle(4,DRAW_NONE);
	SetIndexBuffer(5,NegBuf);   SetIndexStyle(5,DRAW_NONE);
//---- indicator line
	return(0);
}
int start()
{
	double rrr;
	int i;   
	
	for (i = 0; i<=30; i++)
	{
		ArrayCopySeries(ExtBuf,MODE_CLOSE,Symbol(),Period());
		ExtBuf[0]=ExtBuf[0]-i*10*Point;	ExtBuf[1]=ExtBuf[1]-i*10*Point;	
		CountRSI();
		Print("iRSIOnArray   "+ DoubleToStr(RSIArr[0], 4)+"    RSIBuf()   "+ DoubleToStr(RSIBuf[0], 4)+"      iRSI   "+ DoubleToStr(RSI[0], 4) + "    - "+i);
	}
}

double CountRSI()
{
	int i;
	for (i = Bars-1; i>=0; i--)
		RSI[i] = iRSI(Symbol(), 0, RSIPeriod, PRICE_CLOSE, i);//*1.05;

	for (i = Bars-1; i>=0; i--)
		RSIArr[i] = iRSIOnArray(ExtBuf, 0, RSIPeriod, i);//*1.1;
	
	double rel,negative,positive;
   i=Bars-RSIPeriod-1;
   while(i>=0)
     {
      double sumn=0.0,sump=0.0;
      if(i==Bars-RSIPeriod-1)
        {
         int k=Bars-2;
         //---- initial accumulation
         while(k>=i)
           {
            rel=ExtBuf[k]-ExtBuf[k+1];
            if(rel>0) sump+=rel;
            else      sumn-=rel;
            k--;
           }
         positive=sump/RSIPeriod;
         negative=sumn/RSIPeriod;
        }
      else
        {
         //---- smoothed moving average
         rel=ExtBuf[i]-ExtBuf[i+1];
         if(rel>0) sump=rel;
         else      sumn=-rel;
         positive=(PosBuf[i+1]*(RSIPeriod-1)+sump)/RSIPeriod;
         negative=(NegBuf[i+1]*(RSIPeriod-1)+sumn)/RSIPeriod;
        }
      PosBuf[i]=positive;
      NegBuf[i]=negative;
      if(negative==0.0) RSIBuf[i]=100.0;
      else RSIBuf[i]=100.0-100.0/(1+positive/negative);
      i--;
     }
//----
	double rrr = RSIBuf[0];
	return(rrr);
}